// SkinDialog.cpp : implementation file
//

#include "stdafx.h"
#include "SkinDialog.h"


#define MSG_CLICK_CAPTION		0x00F012
// CSkinDialog dialog
CSkinDialog::CSkinDialog(UINT nResourceID, CWnd* pParent /*=NULL*/)
	: CDialog(nResourceID, pParent)
{
	//{{AFX_DATA_INIT(CShapeDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_CtlColorBrush.CreateSolidBrush(Global.GetRGB(IDX_RGB_BACKGROUND));

	m_nClickedBox	= CLICKED_BOX_NONE;

	m_bTracking		= FALSE;

	m_bDraging		= FALSE;
	m_bSizeCursor	= FALSE;

	m_bActive		= FALSE;
	m_bMaxWnd		= FALSE;

	m_cfText		= RGB(0, 0, 0);
	m_cfMask		= RGB(255, 0, 255);

	m_hRgnWnd		= NULL;
	m_hBmpCapL		= NULL;
	m_hBmpCapM		= NULL;
	m_hBmpCapR		= NULL;
	m_hBmpFrmL		= NULL;
	m_hBmpFrmLB		= NULL;
	m_hBmpFrmB		= NULL;
	m_hBmpFrmR		= NULL;
	m_hBmpFrmRB		= NULL;

	m_hBmpMinimize	= NULL;
	m_hBmpMaximize	= NULL;
	m_hBmpRestore	= NULL;
	m_hBmpExit		= NULL;
	m_hBmpCustom    = NULL;

	m_hIcon			= NULL;
	m_bShowTitle    = TRUE;
	m_bWindowText	= false;
	m_strWindowText = L"";
	m_bModalChildCreated = false;

	m_nMinWidth = 0;
	m_nMinHeight = 0;

	m_bExitBtnActHide = FALSE;

	m_bCloseEvent = FALSE;
	m_bWindowMove = TRUE;

	m_bUserBottomButton = TRUE;
	m_cfBK = RGB(244, 244, 244);

	memset(&m_sizeCapL, 0x00, sizeof(SIZE));
	memset(&m_sizeCapM, 0x00, sizeof(SIZE));
	memset(&m_sizeCapR, 0x00, sizeof(SIZE));
	memset(&m_sizeFrmL, 0x00, sizeof(SIZE));
	memset(&m_sizeFrmLB, 0x00, sizeof(SIZE));
	memset(&m_sizeFrmB, 0x00, sizeof(SIZE));
	memset(&m_sizeFrmRB, 0x00, sizeof(SIZE));
	memset(&m_sizeFrmR, 0x00, sizeof(SIZE));
	memset(&m_sizeBox, 0x00, sizeof(SIZE));
	memset(&m_sizeCustomBox, 0x00, sizeof(SIZE));

	m_bShowCustomBtn = FALSE;
	m_bMoveTransParent = TRUE;

	m_rcOldClient = CRect(0,0,0,0);
	m_nTextFontHeight = 10;
	m_clrText = Color(0, 0, 0);
    m_rcCustomBox.SetRectEmpty();

	m_hBmpUserBottomBK = NULL;
	m_sizeUserBottomBK.cx = 0;
	m_sizeUserBottomBK.cy = 0;
	m_hBmpUserBottom = NULL;
	m_sizeUserBottom.cx = 0;
	m_sizeUserBottom.cy = 0;
}

void CSkinDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CSkinDialog, CDialog)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_WM_NCPAINT()
	ON_WM_NCACTIVATE()
	ON_WM_NCCALCSIZE()
	ON_WM_CTLCOLOR()
	ON_WM_GETMINMAXINFO()
	ON_MESSAGE(WM_POPUPSYSTEMMENU, OnPopupSystemMenu)
	ON_WM_NCHITTEST()
END_MESSAGE_MAP()

BOOL CSkinDialog::SetLeftTopBitmap(CString strPath)
{
	Global.SetLeftTopBitmap(strPath);
	m_sizeCapL		= Global.GetBitmapSize(IDX_BMP_CAPTION_LEFT);
	m_hBmpCapL		= Global.GetBitmap(IDX_BMP_CAPTION_LEFT);

	return TRUE;
}


BOOL CSkinDialog::SetLeftTopPNG( CString strPath )
{
	HBITMAP hBitmap = LoadPngToBmp(strPath);
	if(hBitmap == NULL)
	{
		return FALSE;
	}

	Global.SetLeftTopBitmap(hBitmap);

	m_sizeCapL		= Global.GetBitmapSize(IDX_BMP_CAPTION_LEFT);
	m_hBmpCapL		= Global.GetBitmap(IDX_BMP_CAPTION_LEFT);
	
	return TRUE;
}


BOOL CSkinDialog::SetCenterTopBitmap(CString strPath)
{
	Global.SetCenterTopBitmap(strPath);
	m_sizeCapM		= Global.GetBitmapSize(IDX_BMP_CAPTION_CENTER);
	m_hBmpCapM		= Global.GetBitmap(IDX_BMP_CAPTION_CENTER);

	return TRUE;
}


BOOL CSkinDialog::SetCenterTopPNG( CString strPath )
{
	HBITMAP hBitmap = LoadPngToBmp(strPath);
	if(hBitmap == NULL)
	{
		return FALSE;
	}

	Global.SetCenterTopBitmap(hBitmap);
	m_sizeCapM		= Global.GetBitmapSize(IDX_BMP_CAPTION_CENTER);
	m_hBmpCapM		= Global.GetBitmap(IDX_BMP_CAPTION_CENTER);

	return TRUE;
}


BOOL CSkinDialog::SetRightTopBitmap(CString strPath)
{
	Global.SetRightTopBitmap(strPath);
	m_sizeCapR		= Global.GetBitmapSize(IDX_BMP_CAPTION_RIGHT);
	m_hBmpCapR		= Global.GetBitmap(IDX_BMP_CAPTION_RIGHT);

	return TRUE;
}


BOOL CSkinDialog::SetRightTopPNG( CString strPath )
{
	HBITMAP hBitmap = LoadPngToBmp(strPath);
	if(hBitmap == NULL)
	{
		return FALSE;
	}

	Global.SetRightTopBitmap(hBitmap);
	m_sizeCapR		= Global.GetBitmapSize(IDX_BMP_CAPTION_RIGHT);
	m_hBmpCapR		= Global.GetBitmap(IDX_BMP_CAPTION_RIGHT);

	return TRUE;
}

BOOL CSkinDialog::SetLeftBorderBitmap(CString strPath)
{
	Global.SetLeftBorderBitmap(strPath);
	m_sizeFrmL		= Global.GetBitmapSize(IDX_BMP_FRAME_LEFT);
	m_hBmpFrmL		= Global.GetBitmap(IDX_BMP_FRAME_LEFT);

	return TRUE;
}


BOOL CSkinDialog::SetLeftBorderPNG( CString strPath )
{
	HBITMAP hBitmap = LoadPngToBmp(strPath);
	if(hBitmap == NULL)
	{
		return FALSE;
	}

	Global.SetLeftBorderBitmap(hBitmap);
	m_sizeFrmL		= Global.GetBitmapSize(IDX_BMP_FRAME_LEFT);
	m_hBmpFrmL		= Global.GetBitmap(IDX_BMP_FRAME_LEFT);

	return TRUE;
}


BOOL CSkinDialog::SetRightBorderBitmap(CString strPath)
{
	Global.SetRightBorderBitmap(strPath);
	m_sizeFrmR		= Global.GetBitmapSize(IDX_BMP_FRAME_RIGHT);
	m_hBmpFrmR		= Global.GetBitmap(IDX_BMP_FRAME_RIGHT);

	return TRUE;
}


BOOL CSkinDialog::SetRightBorderPNG( CString strPath )
{
	HBITMAP hBitmap = LoadPngToBmp(strPath);
	if(hBitmap == NULL)
	{
		return FALSE;
	}

	Global.SetRightBorderBitmap(hBitmap);
	m_sizeFrmR		= Global.GetBitmapSize(IDX_BMP_FRAME_RIGHT);
	m_hBmpFrmR		= Global.GetBitmap(IDX_BMP_FRAME_RIGHT);

	return TRUE;
}

BOOL CSkinDialog::SetLeftBottomBitmap(CString strPath)
{
	Global.SetLeftBottomBitmap(strPath);
	m_sizeFrmLB		= Global.GetBitmapSize(IDX_BMP_FRAME_LEFT_BOTTOM);
	m_hBmpFrmLB		= Global.GetBitmap(IDX_BMP_FRAME_LEFT_BOTTOM);

	return TRUE;
}


BOOL CSkinDialog::SetLeftBottomPNG( CString strPath )
{
	HBITMAP hBitmap = LoadPngToBmp(strPath);
	if(hBitmap == NULL)
	{
		return FALSE;
	}

	Global.SetLeftBottomBitmap(hBitmap);
	m_sizeFrmLB		= Global.GetBitmapSize(IDX_BMP_FRAME_LEFT_BOTTOM);
	m_hBmpFrmLB		= Global.GetBitmap(IDX_BMP_FRAME_LEFT_BOTTOM);

	return TRUE;
}


BOOL CSkinDialog::SetCenterBottomBitmap(CString strPath)
{
	Global.SetCenterBottomBitmap(strPath);
	m_sizeFrmB		= Global.GetBitmapSize(IDX_BMP_FRAME_BOTTOM);
	m_hBmpFrmB		= Global.GetBitmap(IDX_BMP_FRAME_BOTTOM);

	return TRUE;
}


BOOL CSkinDialog::SetCenterBottomPNG( CString strPath )
{
	HBITMAP hBitmap = LoadPngToBmp(strPath);
	if(hBitmap == NULL)
	{
		return FALSE;
	}

	Global.SetCenterBottomBitmap(hBitmap);
	m_sizeFrmB		= Global.GetBitmapSize(IDX_BMP_FRAME_BOTTOM);
	m_hBmpFrmB		= Global.GetBitmap(IDX_BMP_FRAME_BOTTOM);

	return TRUE;
}


BOOL CSkinDialog::SetRightBottomBitmap(CString strPath)
{
	Global.SetRightBottomBitmap(strPath);
	m_sizeFrmRB		= Global.GetBitmapSize(IDX_BMP_FRAME_RIGHT_BOTTOM);
	m_hBmpFrmRB		= Global.GetBitmap(IDX_BMP_FRAME_RIGHT_BOTTOM);

	return TRUE;
}


BOOL CSkinDialog::SetRightBottomPNG( CString strPath )
{
	HBITMAP hBitmap = LoadPngToBmp(strPath);
	if(hBitmap == NULL)
	{
		return FALSE;
	}

	Global.SetRightBottomBitmap(hBitmap);
	m_sizeFrmRB		= Global.GetBitmapSize(IDX_BMP_FRAME_RIGHT_BOTTOM);
	m_hBmpFrmRB		= Global.GetBitmap(IDX_BMP_FRAME_RIGHT_BOTTOM);

	return TRUE;
}


BOOL CSkinDialog::SetDlgIcon(CString strPath)
{
	Global.SetDlgIcon(strPath);
	m_hIcon			= Global.GetIcon(ICON16);			

	return TRUE;
}

BOOL CSkinDialog::SetMaxBitmaps(CString strNormalPath, CString strOverPath, CString strClickPath)
{
	Global.SetMaxBitmaps(strNormalPath, strOverPath, strClickPath);
	m_hBmpMaximize	= Global.GetBitmap(IDX_BMP_BOX_MAXMIZE);

	return TRUE;
}

BOOL CSkinDialog::SetRestoreBitmaps(CString strNormalPath, CString strOverPath, CString strClickPath)
{
	Global.SetRestoreBitmaps(strNormalPath, strOverPath, strClickPath);
	m_hBmpRestore	= Global.GetBitmap(IDX_BMP_BOX_RESTORE);

	return TRUE;
}

BOOL CSkinDialog::SetMinBitmaps(CString strNormalPath, CString strOverPath, CString strClickPath)
{
	Global.SetMinBitmaps(strNormalPath, strOverPath, strClickPath);
	m_hBmpMinimize	= Global.GetBitmap(IDX_BMP_BOX_MINIMIZE);

	return TRUE;
}

BOOL CSkinDialog::SetExitBitmaps(CString strNormalPath, CString strOverPath, CString strClickPath)
{
	Global.SetExitBitmaps(strNormalPath, strOverPath, strClickPath);
	m_sizeBox		= Global.GetBitmapSize(IDX_BMP_BOX_EXIT);
	m_hBmpExit		= Global.GetBitmap(IDX_BMP_BOX_EXIT);

	return TRUE;
}

BOOL CSkinDialog::SetCustomBitmaps(CString strNormalPath, CString strOverPath, CString strClickPath)
{
	Global.SetCustomBitmaps(strNormalPath, strOverPath, strClickPath);
	m_sizeCustomBox		= Global.GetBitmapSize(IDX_BMP_BOX_CUSTOM);
	m_hBmpCustom		= Global.GetBitmap(IDX_BMP_BOX_CUSTOM);

	return TRUE;
}

void CSkinDialog::SetWindowMinSize(int nWidth, int nHeight)
{
	m_nMinWidth = nWidth;
	m_nMinHeight = nHeight;
}

void CSkinDialog::SetDlgBKColor(COLORREF bkcolor)
{
	m_cfBK = bkcolor;
}

CRect CSkinDialog::GetCustomBtnRect(void)
{
	return m_rcCustomBox;
}

void CSkinDialog::ShowCustomBtn(bool bShow)
{
	m_bShowCustomBtn = bShow;
}

void CSkinDialog::SetDlgIcon(UINT nResourceID)
{
	Global.SetDlgIcon(nResourceID);

	m_hIcon = Global.GetIcon(ICON16);
}

// CSkinDialog message handlers
void CSkinDialog::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	if (m_nMinWidth > 0 && m_nMinHeight > 0)
	{
		lpMMI->ptMinTrackSize.x = m_nMinWidth;
		lpMMI->ptMinTrackSize.y = m_nMinHeight;
		//lpMMI->ptMaxTrackSize.x = m_nMinWidth;
		//lpMMI->ptMaxTrackSize.y = m_nMinHeight;
	}

	CDialog::OnGetMinMaxInfo(lpMMI);
}

BOOL CSkinDialog::OnInitDialog()
{
	CDialog::OnInitDialog();

	ModifyStyle(WS_SYSMENU, 0);

	return TRUE;
}

BOOL CSkinDialog::OnCommand(WPARAM wParam, LPARAM lParam)
{
    switch(LOWORD(wParam)) 
	{    
	case SC_SIZE:    
	case SC_MOVE:    
	case SC_MINIMIZE:    
	case SC_MAXIMIZE:   
	case SC_CLOSE:    
	case SC_RESTORE:        
		PostMessage(WM_SYSCOMMAND, wParam, lParam);        
		break;    
	}

	return __super::OnCommand(wParam, lParam);
}
int CSkinDialog::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;

    m_toolTip.Create(this);
    m_toolTip.Activate(TRUE);
    
	Global.SetRGB(IDX_RGB_MASK, RGB(255, 0, 255));
	Global.SetRGB(IDX_RGB_BACKGROUND, RGB(255, 255, 255));

	Global.SetRGB(IDX_RGB_FONT, RGB(51, 51, 51));
	Global.SetRGB(IDX_RGB_FONT_CAPTION, RGB(0, 0, 0));
	Global.SetRGB(IDX_RGB_FONT_CAPTION_INACTIVE, RGB(178, 178, 178));

	m_cfText = Global.GetRGB(IDX_RGB_FONT_CAPTION);
	m_cfMask = Global.GetRGB(IDX_RGB_MASK);	

	return 0;
}

HBRUSH CSkinDialog::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	if (pWnd && pWnd->IsKindOf(RUNTIME_CLASS(CButton)))
	{
		return (HBRUSH)m_CtlColorBrush;
	}

	return hbr;
}

void CSkinDialog::OnDestroy() 
{
	if (m_hRgnWnd)
		DeleteObject(m_hRgnWnd);
	if (m_CtlColorBrush.GetSafeHandle())
		m_CtlColorBrush.DeleteObject();	
	if (m_fntBold.GetSafeHandle())
		m_fntBold.DeleteObject();

	CDialog::OnDestroy();
}

void CSkinDialog::DrawFrame()
{
	if (!(GetWindowLong(GetSafeHwnd(), GWL_STYLE) & WS_CAPTION) || (!IsWindow(m_hWnd)))
		return;

	int x = 0, y = 0, x2 = 0, y2 = 0, cx = 0, cy = 0;

    CRect rc(0, 0, 0, 0);
	GetWindowRect(&rc);
	CRect rtPS(0, 0, 0, 0);
	rtPS.right = rc.Width();
	rtPS.bottom = rc.Height();

	BOOL bIconic = IsIconic();
	BOOL bZoomed = IsZoomed();

	CWindowDC dc(this);	

	CDC BufferDC, tmpDC;
	BufferDC.CreateCompatibleDC(&dc);
	tmpDC.CreateCompatibleDC(&dc);

	CBitmap bmpBuffer, *pOldBitmap1 = NULL;
	HGDIOBJ hgdiobj;

	bmpBuffer.CreateCompatibleBitmap(&dc, rc.Width(), rc.Height());
	pOldBitmap1 = (CBitmap*)BufferDC.SelectObject(&bmpBuffer);

	if (bZoomed)
	{
		x = 0;
		y = 0;
	}
	else
	{
		x = 0;
		y = 0;
	}

	cx = m_sizeCapL.cx;
	cy = m_sizeCapL.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpCapL);
	BufferDC.BitBlt(x, y, cx, cy, &tmpDC, 0, 0, SRCCOPY);
	tmpDC.SelectObject(hgdiobj);

	x += cx;
	cx = rc.Width() - m_sizeCapL.cx - m_sizeCapR.cx;
	cy = m_sizeCapM.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpCapM);
	BufferDC.StretchBlt(x, y, cx, cy, &tmpDC, 0, 0, m_sizeCapM.cx, m_sizeCapM.cy, SRCCOPY);
	tmpDC.SelectObject(hgdiobj);

	x += cx;
	cx = m_sizeCapR.cx;
	cy = m_sizeCapR.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpCapR);
	BufferDC.BitBlt(x, y, cx, cy, &tmpDC, 0, 0, SRCCOPY);
	tmpDC.SelectObject(hgdiobj);

	x = 0;
	y = m_sizeCapL.cy;
	cx = m_sizeFrmL.cx;
	cy = rc.Height() - m_sizeCapL.cy - m_sizeFrmB.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpFrmL);
	BufferDC.StretchBlt(x, y, cx, cy, &tmpDC, 0, 0, m_sizeFrmL.cx, m_sizeFrmL.cy, SRCCOPY);
	tmpDC.SelectObject(hgdiobj);



	y += cy;
	cx = m_sizeFrmLB.cx;
	cy = m_sizeFrmLB.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpFrmLB);
	BufferDC.BitBlt(x, y, cx, cy, &tmpDC, 0, 0, SRCCOPY);
	tmpDC.SelectObject(hgdiobj);

	if(m_bUserBottomButton)
	{
		x += cx;
		y = rc.Height() - m_sizeUserBottomBK.cy;
		cx = rc.Width() - m_sizeFrmL.cx - m_sizeFrmR.cx;
		cy = m_sizeUserBottomBK.cy;
		hgdiobj = tmpDC.SelectObject(m_hBmpUserBottomBK);
		BufferDC.StretchBlt(x, y, cx, cy, &tmpDC, 0, 0, m_sizeUserBottomBK.cx, m_sizeUserBottomBK.cy, SRCCOPY);
		tmpDC.SelectObject(hgdiobj);

		x = (rc.Width() - m_sizeFrmL.cx - m_sizeFrmR.cx - 1) / 2 + m_sizeFrmL.cx;//m_sizeFrmL.cx + m_pWGButtons->GetUserBottomPos(0);
		cx = 1;
		hgdiobj = tmpDC.SelectObject(m_hBmpUserBottom);
		BufferDC.StretchBlt(x, y, cx, cy, &tmpDC, 0, 0, m_sizeUserBottom.cx, m_sizeUserBottom.cy, SRCCOPY);
		tmpDC.SelectObject(hgdiobj);
	}


	x += cx;
	cx = rc.Width() - m_sizeFrmL.cx - m_sizeFrmR.cx;
	cy = m_sizeFrmB.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpFrmB);
	BufferDC.StretchBlt(x, y, cx, cy, &tmpDC, 0, 0, m_sizeFrmB.cx, m_sizeFrmB.cy, SRCCOPY);
	tmpDC.SelectObject(hgdiobj);

	x = rc.Width() - m_sizeFrmR.cx;
	y = m_sizeCapR.cy;
	cx = m_sizeFrmR.cx;
	cy = rc.Height() - m_sizeCapR.cy - m_sizeFrmRB.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpFrmR);
	BufferDC.StretchBlt(x, y, cx, cy, &tmpDC, 0, 0, m_sizeFrmR.cx, m_sizeFrmR.cy, SRCCOPY);
	tmpDC.SelectObject(hgdiobj);

	x = rc.Width() - m_sizeFrmRB.cx;
	y += cy;
	cx = m_sizeFrmRB.cx;
	cy = m_sizeFrmRB.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpFrmRB);
	BufferDC.BitBlt(x, y, cx, cy, &tmpDC, 0, 0, SRCCOPY);	
	tmpDC.SelectObject(hgdiobj);


	if (!bIconic)
	{
		if (bZoomed)
			::DrawIconEx(BufferDC.m_hDC, 15, 14, m_hIcon, 16, 16, 0, NULL, DI_NORMAL);
		else
			::DrawIconEx(BufferDC.m_hDC, 15, 5, m_hIcon, 16, 16, 0, NULL, DI_NORMAL);

		if (bZoomed)
			y = GetSystemMetrics(SM_CYFRAME);
		else
			y = y = (m_sizeCapM.cy - m_sizeBox.cy) / 2;;	//!

		hgdiobj = tmpDC.SelectObject(m_hBmpExit);
		x = rc.Width() - MARGIN_BOX - DEF_BTN_MARGIN_RIGHT_POS_X - m_sizeBox.cx;
		BufferDC.BitBlt(x, y, m_sizeBox.cx, m_sizeBox.cx, &tmpDC, 0, 0, SRCCOPY);
		tmpDC.SelectObject(hgdiobj);

		if (m_hBmpMaximize)
		{
			if (!m_bMaxWnd)
			{
				hgdiobj = tmpDC.SelectObject(m_hBmpMaximize);
				x = x - DEF_SYSTEM_BTN_GAP - m_sizeBox.cx;			
				BufferDC.BitBlt(x, y, m_sizeBox.cx, m_sizeBox.cx, &tmpDC, 0, 0, SRCCOPY);
				tmpDC.SelectObject(hgdiobj);
			}
			else
			{
				hgdiobj = tmpDC.SelectObject(m_hBmpRestore);
				x = x - DEF_SYSTEM_BTN_GAP - m_sizeBox.cx;			
				BufferDC.BitBlt(x, y, m_sizeBox.cx, m_sizeBox.cx, &tmpDC, 0, 0, SRCCOPY);
				tmpDC.SelectObject(hgdiobj);
			}
		}

		if (m_hBmpMinimize)
		{
			hgdiobj = tmpDC.SelectObject(m_hBmpMinimize);
			x = x - DEF_SYSTEM_BTN_GAP - m_sizeBox.cx;		
			BufferDC.BitBlt(x, y, m_sizeBox.cx, m_sizeBox.cx, &tmpDC, 0, 0, SRCCOPY);
			tmpDC.SelectObject(hgdiobj);
		}

		if (m_hBmpCustom && m_bShowCustomBtn)
		{
			hgdiobj = tmpDC.SelectObject(m_hBmpCustom);
			x = x - DEF_SYSTEM_BTN_GAP - m_sizeCustomBox.cx;		
			BufferDC.BitBlt(x, y, m_sizeCustomBox.cx, m_sizeCustomBox.cy, &tmpDC, 0, 0, SRCCOPY);
			m_rcCustomBox.left = x;
			m_rcCustomBox.right = x + m_sizeCustomBox.cx;
			m_rcCustomBox.top = y;
			m_rcCustomBox.bottom = y + m_sizeCustomBox.cy;
			tmpDC.SelectObject(hgdiobj);
		}
	}
	else
	{
		::DrawIconEx(BufferDC.m_hDC, 15, 5, m_hIcon, 16, 16, 0, NULL, DI_NORMAL);

		hgdiobj = tmpDC.SelectObject(m_hBmpExit);
		x = rc.Width() - MARGIN_BOX - m_sizeBox.cx;
		BufferDC.BitBlt(x, MARGIN_BOX, m_sizeBox.cx, m_sizeBox.cx, &tmpDC, 0, 0, SRCCOPY);
		tmpDC.SelectObject(hgdiobj);

		if (m_hBmpMaximize)
		{
			hgdiobj = tmpDC.SelectObject(m_hBmpMaximize);
			x = x - m_sizeBox.cx;		
			BufferDC.BitBlt(x, MARGIN_BOX, m_sizeBox.cx, m_sizeBox.cx, &tmpDC, 0, 0, SRCCOPY);
			tmpDC.SelectObject(hgdiobj);
		}

		if (m_hBmpMinimize)
		{
			hgdiobj = tmpDC.SelectObject(m_hBmpRestore);
			x = x - m_sizeBox.cx;		
			BufferDC.BitBlt(x, MARGIN_BOX, m_sizeBox.cx, m_sizeBox.cx, &tmpDC, 0, 0, SRCCOPY);
			tmpDC.SelectObject(hgdiobj);
		}

		if (m_hBmpCustom && m_bShowCustomBtn)
		{
			hgdiobj = tmpDC.SelectObject(m_hBmpCustom);
			x = x - m_sizeCustomBox.cx;		
			BufferDC.BitBlt(x, y, m_sizeCustomBox.cx, m_sizeCustomBox.cx, &tmpDC, 0, 0, SRCCOPY);	
			m_rcCustomBox.left = x;
			m_rcCustomBox.right = x + m_sizeCustomBox.cx;
			m_rcCustomBox.top = y;
			m_rcCustomBox.bottom = y + m_sizeCustomBox.cy;

			tmpDC.SelectObject(hgdiobj);
		}
	}

	tmpDC.DeleteDC();

	BufferDC.SetBkMode(TRANSPARENT);

	CFont* font = GetFont();	
	CFont* pOldFont = NULL;

	if (!m_fntBold.GetSafeHandle() && font)
	{
		LOGFONT logFont;
		font->GetLogFont(&logFont);
		logFont.lfWeight = FW_BOLD;
		m_fntBold.CreateFontIndirect(&logFont);		
	}

	if (m_fntBold.GetSafeHandle())
		pOldFont = (CFont*)BufferDC.SelectObject(&m_fntBold);

	BufferDC.SetTextColor(m_cfText);

	BufferDC.SetTextAlign(TA_LEFT | TA_TOP);

	CString strTitle = _T("");
	GetWindowText(strTitle);
	if (!bIconic && pOldFont)
	{
		CRect rcTitle = rc;

		if (bZoomed)
		{
			rcTitle.left = 10;
			rcTitle.top = 10;				
		}
		else
		{
			rcTitle.left = 5;
			rcTitle.top = 5;
		}
		rcTitle.right = rc.Width() - (m_sizeBox.cx * 3) - 35;
		rcTitle.bottom = rcTitle.top + 15;

		LOGFONT lg;
		pOldFont->GetLogFont(&lg);
		if (strTitle.GetLength() * lg.lfWidth + 20 >= rcTitle.Width())
			strTitle = strTitle.Left(rcTitle.Width() / lg.lfWidth - 5) + _T("...");

		if (m_bShowTitle)
			BufferDC.DrawText(strTitle, rcTitle, DT_LEFT | DT_SINGLELINE|DT_NOPREFIX);

		x = m_sizeFrmL.cx;
		y = m_sizeCapM.cy;
		x2 = rc.Width() - m_sizeFrmR.cx;
		y2 = rc.Height() - m_sizeFrmB.cy;	
		dc.ExcludeClipRect(x, y, x2, y2);
	}
	else
	{
		if (strTitle.GetLength() > 4)
			strTitle = strTitle.Left(4) + _T("...");

		if (m_bShowTitle)
			BufferDC.TextOut(30, (rc.Height() - dc.GetTextExtent(strTitle).cy) / 2, strTitle);
	}

	if (m_bWindowText)
	{
		Graphics graph(BufferDC.GetSafeHdc());

		graph.SetSmoothingMode(SmoothingModeAntiAlias);
		graph.SetInterpolationMode(InterpolationModeHighQualityBicubic);
		graph.SetPageUnit(UnitPixel);

		CRect rtTitle(0, 0, 0, 0);
		CString strDisplay;
		strDisplay = m_strWindowText;
		if(m_strWindowText.GetLength() > MAXIMUM_TITLE_LENGTH)
		{
			strDisplay = m_strWindowText.Left(MAXIMUM_TITLE_LENGTH);
			strDisplay += _T("...");
		}

		REAL fontHeight = m_nTextFontHeight;
		Gdiplus::Font myFont(g_defaultFontFaceName, fontHeight, FontStyleRegular,UnitPixel);
		StringFormat format;
		format.SetAlignment(StringAlignmentNear);
		format.SetLineAlignment(StringAlignmentNear);
		format.SetFormatFlags(0);		
		format.SetTrimming(StringTrimmingEllipsisCharacter);

		SolidBrush brush(m_clrText);

		RectF rSize;
		RectF layoutRect(10, 1, MAXIMUM_TITLE_WIDTH, m_sizeCapM.cy);		
		graph.MeasureString(strDisplay, strDisplay.GetLength(), &myFont, layoutRect, &format, &rSize);

		rSize.Height;
		layoutRect.Y = (float)(layoutRect.Height - rSize.Height)/2 + layoutRect.Y;
		layoutRect.Height = rSize.Height;
		if (layoutRect.Width < MINIMUM_TITLE_WIDTH)
		{
			layoutRect.Width = MINIMUM_TITLE_WIDTH;
		}


		graph.SetPageUnit(UnitPixel);
		graph.DrawString(strDisplay,
			strDisplay.GetLength(),
			&myFont,
			layoutRect,
			&format,
			&brush);

		// 		DrawTextToDest2(&graph,
		// 			strDisplay, &rtPS, &rtTitle,
		// 			g_defaultFontFaceName, 10,
		// 			StringAlignmentNear,
		// 			FontStyleRegular,
		// 			Color(255, 34, 34, 34));
	}


	dc.BitBlt(0, 0, rc.Width(), rc.Height(), &BufferDC, 0, 0, SRCCOPY);

	if (pOldFont)
		BufferDC.SelectObject(pOldFont);

	BufferDC.SelectObject(pOldBitmap1);
	BufferDC.DeleteDC();

}

BOOL CSkinDialog::OnNcActivate(BOOL bActive)
{
	if ((GetWindowLong(GetSafeHwnd(), GWL_STYLE) & WS_CAPTION) && (IsWindow(m_hWnd)))
	{
		DrawFrame();
		return TRUE;
	}
	else
	{
		return CDialog::OnNcActivate(bActive);
	}
}

void CSkinDialog::SetCtlColor(COLORREF crCtlColor)
{
	m_CtlColorBrush.DeleteObject();
	m_CtlColorBrush.CreateSolidBrush(crCtlColor);

	RedrawWindow();
}

BOOL CSkinDialog::PreTranslateMessage(MSG* pMsg) 
{
    m_toolTip.RelayEvent(pMsg);

    if ((pMsg->message == WM_SYSKEYDOWN && pMsg->wParam == VK_F4) ||
		 pMsg->wParam == VK_ESCAPE)
	{
		
		//ĬΪǹرնԻΪͻᵥ 	return __super::PreTranslateMessage(pMsg);
		//Դ˴ע͵Ӱ죻
	}	
	else if (pMsg->message == WM_NCLBUTTONDOWN ||
			 pMsg->message == WM_NCMOUSEMOVE ||
			 pMsg->message == WM_LBUTTONUP ||
			 pMsg->message == WM_NCLBUTTONUP ||
			 pMsg->message == WM_NCMOUSELEAVE ||
			 pMsg->message == WM_NCLBUTTONDBLCLK)
	{
		if (GetWindowLong(GetSafeHwnd(), GWL_STYLE) & WS_CAPTION)
		{
			CRect rc(0, 0, 0, 0);
			GetWindowRect(&rc);

			CRect rcExit(0, 0, 0, 0), rcMaximize(0, 0, 0, 0), rcMinimize(0, 0, 0, 0), rcCustom(0, 0, 0, 0);

			int x = 0, y = 0, cx = 0, cy = 0;

			SIZE sizeBox = Global.GetBitmapSize(IDX_BMP_BOX_EXIT);

			BOOL bZoomed = IsZoomed();
			BOOL bIconic = IsIconic();
			BOOL bLButton = KEYDOWN(VK_LBUTTON);

			if (bZoomed)
				y = rc.top + GetSystemMetrics(SM_CXFRAME);
			else
				y = rc.top + 7;	//!

			rcExit.left = rc.right - MARGIN_BOX - sizeBox.cx - DEF_BTN_MARGIN_RIGHT_POS_X;
			rcExit.top = y;
			rcExit.right = rcExit.left+sizeBox.cx;
			rcExit.bottom = rcExit.top+sizeBox.cy;

			if (m_hBmpMaximize)
			{
				rcMaximize.left = rcExit.left - sizeBox.cx - DEF_SYSTEM_BTN_GAP;
				rcMaximize.top = y;
				rcMaximize.right = rcMaximize.left + sizeBox.cx;
				rcMaximize.bottom = rcMaximize.top + sizeBox.cy;
			}

			if (m_hBmpMinimize)
			{
				if (m_hBmpMaximize)
					rcMinimize.left = rcMaximize.left - sizeBox.cx - DEF_SYSTEM_BTN_GAP;
				else
					rcMinimize.left = rcExit.left - sizeBox.cx - DEF_SYSTEM_BTN_GAP;
				rcMinimize.top = y;
				rcMinimize.right = rcMinimize.left + sizeBox.cx;
				rcMinimize.bottom = rcMinimize.top + sizeBox.cy;
			}

			if (m_hBmpCustom)
			{
				rcCustom.left = rcMinimize.left - m_sizeCustomBox.cx - DEF_SYSTEM_BTN_GAP;
				rcCustom.top = y;
				rcCustom.right = rcCustom.left + m_sizeCustomBox.cx;
				rcCustom.bottom = rcCustom.top + m_sizeCustomBox.cy;
			}

			switch (pMsg->message)
			{
			case WM_NCLBUTTONDOWN:
				{
					if (pMsg->hwnd != this->GetSafeHwnd())
						break;

					this->SetForegroundWindow();

					if (rcExit.PtInRect(pMsg->pt))
					{
						SetCapture();
						m_nClickedBox = CLICKED_BOX_EXIT;
						m_hBmpExit = Global.GetBitmap(IDX_BMP_BOX_EXIT_ON);
						DrawFrame();

						return TRUE;
					}
					else if (rcMaximize.PtInRect(pMsg->pt))
					{
						SetCapture();
						m_nClickedBox = CLICKED_BOX_MAXIMIZE;
						if (m_bMaxWnd)
							m_hBmpRestore = Global.GetBitmap(IDX_BMP_BOX_RESTORE_ON);
						else
							m_hBmpMaximize = Global.GetBitmap(IDX_BMP_BOX_MAXMIZE_ON);
						DrawFrame();

						return TRUE;
					}
					else if (rcMinimize.PtInRect(pMsg->pt))
					{
						SetCapture();
						m_nClickedBox = CLICKED_BOX_MINIMIZE;
						if (bIconic)
							m_hBmpRestore = Global.GetBitmap(IDX_BMP_BOX_RESTORE_ON);
						else
							m_hBmpMinimize = Global.GetBitmap(IDX_BMP_BOX_MINIMIZE_ON);
						DrawFrame();

						return TRUE;
					}
					else if (rcCustom.PtInRect(pMsg->pt) && m_bShowCustomBtn)
					{
						SetCapture();
						m_nClickedBox = CLICKED_BOX_CUSTOM;
						m_hBmpCustom = Global.GetBitmap(IDX_BMP_BOX_CUSTOM_ON);
						DrawFrame();

						return TRUE;
					}
					else
					{
						m_nClickedBox = CLICKED_BOX_NONE;
						if (m_bMaxWnd)
						{
							return TRUE;
						}
						
					}
				}
				break;
			case WM_NCMOUSELEAVE:
				{
					m_bTracking = FALSE;
					if (m_nClickedBox == CLICKED_BOX_NONE)
					{					
						m_hBmpMinimize = Global.GetBitmap(IDX_BMP_BOX_MINIMIZE);
						m_hBmpMaximize = Global.GetBitmap(IDX_BMP_BOX_MAXMIZE);
						m_hBmpRestore = Global.GetBitmap(IDX_BMP_BOX_RESTORE);
						m_hBmpExit = Global.GetBitmap(IDX_BMP_BOX_EXIT);
						m_hBmpCustom = Global.GetBitmap(IDX_BMP_BOX_CUSTOM);
						m_nClickedBox = CLICKED_BOX_NONE;

						DrawFrame();
                        m_toolTip.DelTool(this);
					}
				}
				break;
			case WM_NCLBUTTONDBLCLK:
				{
					if (pMsg->hwnd != this->GetSafeHwnd())
						break;
					if(m_bMaxWnd)
					{
						this->ShowWindow(SW_RESTORE);
					}
					else
					{
						this->ShowWindow(SW_MAXIMIZE);
					}
					DrawFrame();
					return TRUE;
				}
				break;
			case WM_NCMOUSEMOVE:
				{
					if (!m_bTracking)
					{
						m_bTracking = TRUE;
						TRACKMOUSEEVENT t = { sizeof(TRACKMOUSEEVENT), TME_NONCLIENT|TME_LEAVE, m_hWnd, 0 };
						::TrackMouseEvent(&t);					
					}

					if (m_nClickedBox != CLICKED_BOX_NONE)
						break;
					
					m_hBmpMinimize = Global.GetBitmap(IDX_BMP_BOX_MINIMIZE);
					m_hBmpMaximize = Global.GetBitmap(IDX_BMP_BOX_MAXMIZE);
					m_hBmpRestore = Global.GetBitmap(IDX_BMP_BOX_RESTORE);
					m_hBmpExit = Global.GetBitmap(IDX_BMP_BOX_EXIT);	
					m_hBmpCustom = Global.GetBitmap(IDX_BMP_BOX_CUSTOM);
                    CString strToolTip;

					//::SetCursor(::LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW)));
					if (rcExit.PtInRect(pMsg->pt))
					{
						::SetCursor(::LoadCursor(NULL, MAKEINTRESOURCE(IDC_HAND)));
                        strToolTip = LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_7);
						m_hBmpExit = Global.GetBitmap(IDX_BMP_BOX_EXIT_OVER);
					}
					else if (rcMaximize.PtInRect(pMsg->pt))
					{
						::SetCursor(::LoadCursor(NULL, MAKEINTRESOURCE(IDC_HAND)));
                        if (m_bMaxWnd){
							m_hBmpRestore = Global.GetBitmap(IDX_BMP_BOX_RESTORE_OVER);
                            strToolTip = LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_6_1);
                        }
                        else{
							m_hBmpMaximize = Global.GetBitmap(IDX_BMP_BOX_MAXMIZE_OVER);
                            strToolTip = LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_6);
                        }
					}
					else if (rcMinimize.PtInRect(pMsg->pt))
					{
						::SetCursor(::LoadCursor(NULL, MAKEINTRESOURCE(IDC_HAND)));
						if (bIconic){
							m_hBmpRestore = Global.GetBitmap(IDX_BMP_BOX_RESTORE_OVER);
                            strToolTip = LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_6_1);
                        }
						else{
							m_hBmpMinimize = Global.GetBitmap(IDX_BMP_BOX_MINIMIZE_OVER);
                            strToolTip = LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_5);
                        }
					}	
					else if (rcCustom.PtInRect(pMsg->pt))
					{
						m_hBmpCustom = Global.GetBitmap(IDX_BMP_BOX_CUSTOM_OVER);
					}
                    
                    if(m_strOldTooltip != strToolTip)
                    {
                        m_toolTip.DelTool(this);
                        if (!strToolTip.IsEmpty())
                        {
                            //FTLTRACE(TEXT("ToolTip=%s\n"), strToolTip);
                            m_toolTip.AddTool(this, strToolTip);
                        }
                        m_strOldTooltip = strToolTip;
                    }
                    
					DrawFrame();
				}				
				break;
			case WM_LBUTTONUP:
			case WM_NCLBUTTONUP:
				{
					if (m_nClickedBox != CLICKED_BOX_NONE || m_bModalChildCreated)
						ReleaseCapture();

					if (rcExit.PtInRect(pMsg->pt))
					{
						if (m_nClickedBox == CLICKED_BOX_EXIT)
						{
							if (m_bExitBtnActHide)
								this->ShowWindow(SW_HIDE);
							else
							{
								if (m_bCloseEvent)
                                {
									PostMessage(WM_CLOSE, 0, 0);
                                }
								else
                                {
									OnOK();
                                }

                                return TRUE;
							}
						}
					}
					else if (rcMaximize.PtInRect(pMsg->pt))
					{
						if (m_nClickedBox == CLICKED_BOX_MAXIMIZE)
						{
							if (m_bMaxWnd)
								this->ShowWindow(SW_RESTORE);
							else
								this->ShowWindow(SW_MAXIMIZE);
						}
					}
					else if (rcMinimize.PtInRect(pMsg->pt))
					{
						if (m_nClickedBox == CLICKED_BOX_MINIMIZE)
						{
							if (bIconic)
								this->ShowWindow(SW_RESTORE);
							else
								this->ShowWindow(SW_MINIMIZE);
						}
					}
					else if (rcCustom.PtInRect(pMsg->pt) && m_bShowCustomBtn)
					{
						if (m_nClickedBox == CLICKED_BOX_CUSTOM)
						{						
							PostMessage(WM_CLICKCUSTOMBTN, 0, 0);
						}
					}
					else
					{					
						m_hBmpMinimize = Global.GetBitmap(IDX_BMP_BOX_MINIMIZE);
						m_hBmpMaximize = Global.GetBitmap(IDX_BMP_BOX_MAXMIZE);
						m_hBmpRestore = Global.GetBitmap(IDX_BMP_BOX_RESTORE);
						m_hBmpExit = Global.GetBitmap(IDX_BMP_BOX_EXIT);
						m_hBmpCustom = Global.GetBitmap(IDX_BMP_BOX_CUSTOM);

						DrawFrame();
					}

					m_nClickedBox = CLICKED_BOX_NONE;
				}
				break;					
			}
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}

void CSkinDialog::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	// Do not call CDialog::OnPaint() for painting messages

}

void CSkinDialog::OnNcPaint()
{
	if (GetWindowLong(GetSafeHwnd(), GWL_STYLE) & WS_CAPTION)
	{
		DrawFrame();
	}
}

void CSkinDialog::OnNcCalcSize(BOOL bCalcValidRects, NCCALCSIZE_PARAMS* lpncsp)
{
	if ((GetWindowLong(GetSafeHwnd(), GWL_STYLE) & WS_CAPTION) && !IsZoomed())
	{
		int revision = 0;

		SIZE size = Global.GetBitmapSize(IDX_BMP_CAPTION_CENTER);
		if (size.cy)
		{
			revision = size.cy - (GetSystemMetrics(SM_CYCAPTION) + GetSystemMetrics(SM_CYFRAME));
			lpncsp->rgrc[0].top += revision;
		}

		size = Global.GetBitmapSize(IDX_BMP_FRAME_LEFT);
		if (size.cx)
		{
			revision = size.cx - GetSystemMetrics(SM_CXFRAME);
			lpncsp->rgrc[0].left += revision;
			//lpncsp->rgrc[0].left -= (GetSystemMetrics(SM_CXFRAME) - 1);
		}

		size = Global.GetBitmapSize(IDX_BMP_FRAME_RIGHT);
		if (size.cx)
		{
			revision = size.cx - GetSystemMetrics(SM_CXFRAME);
			lpncsp->rgrc[0].right -= revision;
			//lpncsp->rgrc[0].right += (GetSystemMetrics(SM_CXFRAME) - 1);
		}

		size = Global.GetBitmapSize(IDX_BMP_FRAME_BOTTOM);
		if (size.cy)
		{
			revision = size.cy - GetSystemMetrics(SM_CXFRAME);
			lpncsp->rgrc[0].bottom -= revision;
		}
	}
	else if (IsZoomed())
	{
		WINDOWINFO WindowInfo;
		::ZeroMemory(&WindowInfo,sizeof(WindowInfo));
		WindowInfo.cbSize=sizeof(WindowInfo);
		GetWindowInfo(&WindowInfo);

		int revision = 0;
		SIZE size = Global.GetBitmapSize(IDX_BMP_CAPTION_CENTER);
		if (size.cy)
		{
			revision = size.cy - (GetSystemMetrics(SM_CYCAPTION) + GetSystemMetrics(SM_CYFRAME));
			lpncsp->rgrc[0].top += revision;
		}

		size = Global.GetBitmapSize(IDX_BMP_FRAME_BOTTOM);
		if (size.cy)
		{
			revision = size.cy - GetSystemMetrics(SM_CXFRAME);
			lpncsp->rgrc[0].bottom -= revision;
		}
	}

	CDialog::OnNcCalcSize(bCalcValidRects, lpncsp);
}

void CSkinDialog::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);

	if (GetWindowLong(GetSafeHwnd(), GWL_STYLE) & WS_CAPTION)
	{
		CRect rc(0, 0, 0, 0);
		GetWindowRect(&rc);

		int nWidth = rc.Width();
		int nHeight = rc.Height();
		int nSX = 0, nSY = 0, nOX = 0, nOY = 0;
		HRGN hRgnA, hRgnB;

		if (nType == SIZE_MAXIMIZED)
		{
			//SIZE sizeRight, sizeLeft, sizeTop, sizeBotton;
			//sizeRight = Global.GetBitmapSize(IDX_BMP_FRAME_RIGHT);			
			//sizeLeft = Global.GetBitmapSize(IDX_BMP_FRAME_LEFT);
			//sizeTop = Global.GetBitmapSize(IDX_BMP_CAPTION_CENTER);
			//sizeBotton = Global.GetBitmapSize(IDX_BMP_FRAME_BOTTOM);
			//nSX = sizeRight.cx;
			//nSY = sizeTop.cy;
			//nWidth -= sizeRight.cx;
			//nHeight -= sizeBotton.cy;

			//nSX = MARGIN_MAXIMIZED;
			//nSY = MARGIN_MAXIMIZED;
			//nWidth -= MARGIN_MAXIMIZED;
			//nHeight -= MARGIN_MAXIMIZED;

			//nSX = GetSystemMetrics(SM_CXFRAME);
			//nSY = GetSystemMetrics(SM_CYFRAME);
			//nWidth -= GetSystemMetrics(SM_CXFRAME);
			//nHeight -= GetSystemMetrics(SM_CYFRAME);
			if(!m_bMaxWnd)
			{
				ShowWindow(SW_MAXIMIZE, FALSE); 
			}
		}

		if (m_hRgnWnd)
			DeleteObject(m_hRgnWnd);

		m_hRgnWnd = CreateRectRgn(nSX, nSY, nWidth, nHeight);

		// caption left
		nSX = 0;
		nSY = 0;
		hRgnA = BitmapToRegion(m_hBmpCapL, RGB(250, 0, 250), RGB(255, 10, 255));
		hRgnB = CreateRectRgn(nSX, nSY, nSX + m_sizeCapL.cx, nSY + m_sizeCapL.cy);

   		if (hRgnA == NULL && hRgnB == NULL)
   			return;

		CombineRgn(hRgnA, hRgnB, hRgnA, RGN_DIFF);
		CombineRgn(m_hRgnWnd, m_hRgnWnd, hRgnA, RGN_DIFF);

		DeleteObject(hRgnA);
		DeleteObject(hRgnB);

		// caption right
		nSX = 0;
		nSY = 0;
		hRgnA = BitmapToRegion(m_hBmpCapR, RGB(250, 0, 250), RGB(255, 10, 255));
		hRgnB = CreateRectRgn(nSX, nSY, nSX + m_sizeCapR.cx, nSY + m_sizeCapR.cy);

		CombineRgn(hRgnA, hRgnB, hRgnA, RGN_DIFF);
		nOX = nWidth - m_sizeCapR.cx;
		nOY = 0;
		OffsetRgn(hRgnA, nOX, nOY);
		CombineRgn(m_hRgnWnd, m_hRgnWnd, hRgnA, RGN_DIFF);

		DeleteObject(hRgnA);
		DeleteObject(hRgnB);

		// bottom left
		nSX = 0;
		nSY = 0;
		hRgnA = BitmapToRegion(m_hBmpFrmLB, RGB(250, 0, 250), RGB(255, 10, 255));
		hRgnB = CreateRectRgn(nSX, nSY, nSX + m_sizeFrmLB.cx, nSY + m_sizeFrmLB.cy);

		CombineRgn(hRgnA, hRgnB, hRgnA, RGN_DIFF);
		nOX = 0;
		nOY = nHeight - m_sizeFrmLB.cy;
		OffsetRgn(hRgnA, nOX, nOY);
		CombineRgn(m_hRgnWnd, m_hRgnWnd, hRgnA, RGN_DIFF);

		DeleteObject(hRgnA);
		DeleteObject(hRgnB);

		// bottom right
		nSX = 0;
		nSY = 0;
		hRgnA = BitmapToRegion(m_hBmpFrmRB, RGB(250, 0, 250), RGB(255, 10, 255));
		hRgnB = CreateRectRgn(nSX, nSY, nSX + m_sizeFrmRB.cx, nSY + m_sizeFrmRB.cy);

		CombineRgn(hRgnA, hRgnB, hRgnA, RGN_DIFF);
		nOX = nWidth - m_sizeFrmRB.cx;
		nOY = nHeight - m_sizeFrmRB.cy;
		OffsetRgn(hRgnA, nOX, nOY);
		CombineRgn(m_hRgnWnd, m_hRgnWnd, hRgnA, RGN_DIFF);

		DeleteObject(hRgnA);
		DeleteObject(hRgnB);

		SetWindowRgn(m_hRgnWnd, TRUE);
	}
}

bool CSkinDialog::IsFocused()
{
	CWnd* pWndFocus = GetForegroundWindow();
	if (pWndFocus && (pWndFocus->GetSafeHwnd() == GetSafeHwnd()))
		return true;

	return false;
}

LRESULT CSkinDialog::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
#if 0
    //code for NTALKCL-1044
    MSG msg = { 0 };
    msg.hwnd = GetSafeHwnd();
    msg.message = message;
    msg.wParam = wParam;
    msg.lParam = lParam;
    GetCursorPos(&msg.pt);
    PMSG pMsg = &msg;

    //move necessory code from CSkinDialog::PreTranslateMessage to CSkinDialog::WindowProc
#endif 

	if (m_bWindowMove)
	{
		if (message == WM_SYSCOMMAND && wParam == MSG_CLICK_CAPTION)
		{
			CRect rc(0, 0, 0, 0);
			GetWindowRect(&rc);
			m_rcOldClient = rc;
		}
		return CDialog::WindowProc(message, wParam, lParam);
	}
	static BOOL bFlag = FALSE; 
	switch( message )
	{
	case WM_NCLBUTTONDOWN:    
		bFlag = TRUE;
	case WM_NCMOUSEMOVE:
		if( bFlag )
		{
			bFlag = FALSE;
			return TRUE;  
		}
		return 0;
	} 

	return CDialog::WindowProc(message, wParam, lParam);
}

LRESULT CSkinDialog::OnPopupSystemMenu(WPARAM wParam, LPARAM lParam)
{
	CMenu *pSysMenu = GetSystemMenu(FALSE);

	if (NULL == pSysMenu)
		return 0L;

	if (IsZoomed()) 
	{
		pSysMenu->EnableMenuItem(SC_SIZE, MF_BYCOMMAND|MF_GRAYED);
		pSysMenu->EnableMenuItem(SC_MOVE, MF_BYCOMMAND|MF_GRAYED);
		pSysMenu->EnableMenuItem(SC_MINIMIZE, MF_BYCOMMAND|MF_ENABLED);
		pSysMenu->EnableMenuItem(SC_MAXIMIZE, MF_BYCOMMAND|MF_GRAYED);
		pSysMenu->EnableMenuItem(SC_RESTORE, MF_BYCOMMAND|MF_ENABLED);
	} else if (IsIconic()) 
	{
		pSysMenu->EnableMenuItem(SC_SIZE, MF_BYCOMMAND|MF_GRAYED);
		pSysMenu->EnableMenuItem(SC_MOVE, MF_BYCOMMAND|MF_GRAYED);
		pSysMenu->EnableMenuItem(SC_MINIMIZE, MF_BYCOMMAND|MF_GRAYED);
		pSysMenu->EnableMenuItem(SC_MAXIMIZE, MF_BYCOMMAND|MF_ENABLED);
		pSysMenu->EnableMenuItem(SC_RESTORE, MF_BYCOMMAND|MF_ENABLED);
	} else 
	{
		pSysMenu->EnableMenuItem(SC_SIZE, MF_BYCOMMAND|MF_ENABLED);
		pSysMenu->EnableMenuItem(SC_MOVE, MF_BYCOMMAND|MF_ENABLED);
		pSysMenu->EnableMenuItem(SC_MINIMIZE, MF_BYCOMMAND|MF_ENABLED);
		pSysMenu->EnableMenuItem(SC_MAXIMIZE, MF_BYCOMMAND|MF_ENABLED);
		pSysMenu->EnableMenuItem(SC_RESTORE, MF_BYCOMMAND|MF_GRAYED);
	}

	DrawFrame();

    POINT pt = {0};
	GetCursorPos(&pt);
	::SetForegroundWindow(GetSafeHwnd());
	pSysMenu->TrackPopupMenu(TPM_LEFTALIGN|TPM_RIGHTBUTTON, pt.x, pt.y, this, NULL);

	return 0L;
}

BOOL CSkinDialog::IsZoomed()
{
	return FALSE;
}

void CSkinDialog::ShowWindow(int nCmdShow, BOOL bCalOldRect)
{
	if (IsWindow(m_hWnd))
	{
		if (nCmdShow == SW_MAXIMIZE)
		{
			m_bMaxWnd = TRUE;
			if (bCalOldRect)
			{
				CRect rc(0, 0, 0, 0);
				GetWindowRect(&rc);
				m_rcOldClient = rc;
			}

			DWORD dwStyle = ::GetWindowLong(m_hWnd, GWL_STYLE);
			dwStyle |= WS_MAXIMIZE;
			SetWindowLong(m_hWnd, GWL_STYLE, dwStyle);

			int nFrameWidth = GetSystemMetrics(SM_CXFRAME);
			int nFrameHeight = GetSystemMetrics(SM_CYFRAME);
			int nMaxClinetWidth = GetSystemMetrics(SM_CXMAXIMIZED) - nFrameWidth*2; 
			int nMaxClinetHeight = GetSystemMetrics(SM_CYMAXIMIZED) - nFrameHeight*2; 

			int nLeft = 1;
			int nTop = 1;
			HMONITOR hMonitor = MonitorFromWindow(m_hWnd, MONITOR_DEFAULTTONEAREST);
			if(hMonitor != NULL)
			{
				MONITORINFO monitorInfo;
				monitorInfo.cbSize = sizeof(monitorInfo);
				BOOL bRet = GetMonitorInfo(hMonitor, &monitorInfo);
				nLeft = monitorInfo.rcWork.left + 1;
				nTop = monitorInfo.rcWork.top + 1;
				nMaxClinetWidth = monitorInfo.rcWork.right - monitorInfo.rcWork.left;
				nMaxClinetHeight = monitorInfo.rcWork.bottom - monitorInfo.rcWork.top;
			}

			CRect WorkArea = CRect(nLeft, nTop, nLeft + nMaxClinetWidth, nTop + nMaxClinetHeight);
			SetWindowPos(NULL, WorkArea.left, WorkArea.top, WorkArea.Width(), WorkArea.Height(), SWP_FRAMECHANGED | SWP_SHOWWINDOW); // NS
		}
		else if(nCmdShow == SW_RESTORE)
		{
			if (m_bMaxWnd)
			{
				DWORD dwStyle = ::GetWindowLong(m_hWnd, GWL_STYLE);
				dwStyle ^= WS_MAXIMIZE;
				SetWindowLong(m_hWnd, GWL_STYLE, dwStyle);
				SetWindowPos(NULL, m_rcOldClient.left, m_rcOldClient.top, m_rcOldClient.Width(), m_rcOldClient.Height(), SWP_FRAMECHANGED | SWP_SHOWWINDOW);
			}
			else
			{
				CDialog::ShowWindow(nCmdShow);
			}	
			m_bMaxWnd = FALSE;
		}
		else
		{
			m_bMaxWnd = FALSE;
			if (bCalOldRect)
			{
				CRect rc(0, 0, 0, 0);
				GetWindowRect(&rc);
				m_rcOldClient = rc;
			}
			CDialog::ShowWindow(nCmdShow);
		}
	}
}


LRESULT CSkinDialog::OnNcHitTest(CPoint point)
{
	// TODO: Add your message handler code here and/or call default
	int ret = CDialog::OnNcHitTest(point);

	//if( HTCAPTION == ret && m_bMaxWnd)
	//	return HTCLIENT;

	if( HTCAPTION != ret )
		return HTCLIENT;

	if((HTTOP == ret || HTBOTTOM == ret || HTLEFT == ret || HTRIGHT == ret || HTBOTTOMLEFT == ret || HTBOTTOMRIGHT == ret || HTTOPLEFT == ret || HTTOPRIGHT == ret) 
		&& m_bMaxWnd)
		return HTCLIENT;
	return ret;
}

void CSkinDialog::SetWindowTextColor( Color clr )
{
	m_clrText = clr;
}

void CSkinDialog::SetWindowTextFontHeight( int nHeight )
{
	m_nTextFontHeight = nHeight;
}

void CSkinDialog::DrawUserFrameEx(CDC* pTempDC, CDC* pBUfferDC, HGDIOBJ hgdiobj)
{

}

BOOL CSkinDialog::SetUserBottomPNGBK( CString strPath )
{
	HBITMAP hBitmap = LoadPngToBmp(strPath);
	if(hBitmap == NULL)
	{
		return FALSE;
	}

	Global.SetUserBottomBitmapBK(hBitmap);
	m_sizeUserBottomBK		= Global.GetBitmapSize(IDX_BMP_FRAME_USER_BOTTOM_BK);
	m_hBmpUserBottomBK		= Global.GetBitmap(IDX_BMP_FRAME_USER_BOTTOM_BK);

	return TRUE;

	return TRUE;
}

BOOL CSkinDialog::SetUserBottomPNG( CString strPath )
{
	HBITMAP hBitmap = LoadPngToBmp(strPath);
	if(hBitmap == NULL)
	{
		return FALSE;
	}

	Global.SetUserBottomBitmap(hBitmap);
	m_sizeUserBottom		= Global.GetBitmapSize(IDX_BMP_FRAME_USER_BOTTOM);
	m_hBmpUserBottom		= Global.GetBitmap(IDX_BMP_FRAME_USER_BOTTOM);

	return TRUE;
}


